/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: URL.h,v 1.13 2002/06/08 10:09:40 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_NET_URL_H
# define INCLUDE_JAKELIB2_NET_URL_H

namespace jakelib {
  namespace net {

    /**
     * @class URL
     * @version $Id: URL.h,v 1.13 2002/06/08 10:09:40 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class URL : public jakelib::lang::Object
      {
      public:
	URL(jbyte* url);
	URL(jakelib::lang::String* url);
	URL(URL* url);
	URL();

	~URL();

	jakelib::lang::String* getHost();
	jakelib::lang::String* getScheme();
	jakelib::lang::String* getFile();
	jakelib::lang::String* getDir();
	jakelib::lang::String* getFName();
	jakelib::lang::String* getExt();
	int getPort();
	void setFile(char* file);
	void setFile(jakelib::lang::String* file);
	void append(char* path);
	void append(jakelib::lang::String* path);
	jakelib::lang::String* toString();
	int hashCode();

	URL& operator = (URL* url);
	URL& operator = (char* url);
  
      protected:
	int port;
	jakelib::lang::String* scheme;
	jakelib::lang::String* host;
	jakelib::lang::String* file;
	jakelib::lang::String* dir;
	jakelib::lang::String* fname;
	jakelib::lang::String* ext;
	jakelib::lang::String* urlString;

	void set(URL* url);
	void set(char* url);
	void extractFName();

	JAKELIB_DECLARE_CLASS(URL);
      };

  }
}
#endif

